/*
 * frost - C++ multi methods as if they were a native feature
 * Copyright (C) 2001, 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	(See file COPYING for more information)
 */

#ifndef _frost_exception_hh
#define _frost_exception_hh


// includes

#include <uds/stdexcpt.hh>

using namespace uds;


/// thrown when a parser error occurs
_uds_ExceptionClass( ParserError, runtime_error, "parser error", NoDiag );

/// generic user error
_uds_ExceptionClass( UserError, runtime_error, "", NoDiag );

/// invalid frost object file
_uds_ExceptionClass( InvFOFile, runtime_error, "invalid frost object file",
					 NoDiag );

/// ambigous multi method call
_uds_ExceptionClass( AmbigousCall, uds::logic_error,
	"ambigous multi method", uds::NoDiag );

/// invalid virtual argument
_uds_ExceptionClass( InvVArg, uds::logic_error,
	"invalid virtual argument", uds::NoDiag );

#endif // _frost_exception_hh
