/*
 * frost - C++ multi methods as if they were a native feature
 * Copyright (C) 2002  Julian v. Bock
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  (See file COPYING for more information)
 */


// includes

#include <iostream>

using namespace std;


class bar;

class foo
{
public:
	virtual
	~foo() {}

	static void
	fwva( virtual foo& ) { cout<<"foo\n"; }
};

class bar : public foo
{
public:
	virtual
	~bar() {}

	static void
	fwva( virtual bar& ) { cout<<"bar\n"; }
};


int
main()
{
	foo     f1;
	bar     b;
	foo&    f2 = b;

	foo::fwva( f1 );
	foo::fwva( f2 );

	return 0;
}
